//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "PrDatView.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
void mkdir_recursive(AnsiString);
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ActionMegnyitas1Execute(TObject *Sender)
{
 if(OpenDialog1->Execute()){
    filename=OpenDialog1->FileName;
    switch(ver){
       case 1: opendat1(); break;
       case 2: opendat2(); break;
       case 3: opendat2mac(); break;
    }
    Form1->Caption=filename;
    filename2=UpperCase(ExtractFileName(filename));
    treat=IntToStr(ver)+"_"+filename2;
    showlist();
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
 int i;
// ms=new TMemoryStream;
 mi=new TMemIniFile(ExtractFilePath(Application->ExeName)+"dat.ini");
 mi2=new TMemIniFile(ExtractFilePath(Application->ExeName)+"exp.ini");
 sl_edit=new TStringList(); sl_edit->LoadFromFile(ExtractFilePath(Application->ExeName)+"edit.ini");
 kep=new Graphics::TBitmap;
/* for(i=0;i<MAX_NUMBER_OF_RES;i++){
    ms_res[i]=NULL;
 }*/
 ms_res=NULL;
 ActionVga1->Checked=true; vga1->Checked=true;
 ActionPrince1->Checked=true; Prince1->Checked=true;
 ActionCompressMax1->Execute();
 if(ParamCount()){
    filename=ParamStr(1);
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
 int i;
/* for(i=0;i<MAX_NUMBER_OF_RES;i++){
    if(ms_res[i]){ delete ms_res[i]; ms_res[i]=NULL; }
 }*/
 delall();
// delete ms;
 delete mi;
 delete mi2;
 delete kep;
 delete sl_edit;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ListBox1Click(TObject *Sender)
{
 show(ListBox1->ItemIndex,false);
}
//---------------------------------------------------------------------------
void TForm1::show(int ix,bool exp){
 AnsiString s,s2,idx; /*TColor c=0;*/ int i,p,offs,r=0;
 if(ix==-1) return;
 s=mi->ReadString(treat,
    ((ver!=1)?AnsiString(poprec[ix].idx)+",":AnsiString(""))+IntToStr(poprec[ix].id),"binary");
 p=s.Pos(","); if(p==0) p=s.Length()+1;
 s2=s.SubString(1,p-1);
 StatusBar1->SimpleText=s2;
 if((exp&&com==0)||s2=="binary"){
//    kep->Width=0; kep->Height=0;
    showbinary(ix,exp);
 }else if(s2=="palettepop1"){
    showpalettepop1(ix,exp);
 }else if(s2=="paletteraw"){
    showpaletteraw(ix,exp);
 }else if(s2=="palettepop2"){
    showpalettepop2(ix,exp);
 }else if(s2=="image"){
    s2=s.SubString(p+1,s.Length()-p);
    if(ver!=1){
       if(s2!=""){
          p=s2.Pos("+");
          if(p==0) p=s2.Length()+1;
          s=s2.SubString(p+1,s2.Length()-p);
          if(s!="") r=StrToInt(s); else r=0;
          s2=s2.SubString(1,p-1);
          p=s2.Pos(",");
          idx=s2.SubString(1,p-1);
          p=StrToInt(s2.SubString(p+1,s2.Length()-p));
       } else p=-1;
    }else{
       if(s2!="") p=StrToInt(s2); else p=-1;
       idx=""; r=0;
    }
    s=mi->ReadString(treat,
       ((ver!=1)?AnsiString(idx)+",":AnsiString(""))+IntToStr(p),"binary");
    if(s=="palettepop1"){
       offs=4;
    }else if(s=="paletteraw"){
       offs=0;
    }else if(s=="palettepop2"){
       offs=7;
    }
    showbitmap(ix,p,idx,offs+r*3,exp);
 }else if(s2=="font"){
    showfont(ix,exp);
 }else if(s2=="text"){
    s2=s.SubString(p+1,s.Length()-p);
    showtext(ix,exp,s2.Pos("4")!=0,s2.Pos("l")!=0);
 }else if(s2=="palettemac"){
    showpalettemac(ix,exp);
 }else if(s2=="imagemac"){
    s2=s.SubString(p+1,s.Length()-p);
       if(s2!=""){
          p=s2.Pos("+");
          if(p==0) p=s2.Length()+1;
          s=s2.SubString(p+1,s2.Length()-p);
          if(s!="") r=StrToInt(s); else r=0;
          s2=s2.SubString(1,p-1);

          p=s2.Pos(",");
          idx=s2.SubString(1,p-1);
          p=StrToInt(s2.SubString(p+1,s2.Length()-p));
       } else p=-1;
    showbitmapmac(ix,p,idx,r,exp);
 }else if(s2=="wave"){
    s2=s.SubString(p+1,s.Length()-p);
    showwave(ix,exp,s2=="2");
 }else{
    kep->Width=0; kep->Height=0;
    ShowMessage("Ismeretlen tpus: "+s);
 }
 PaintBox1->Width=kep->Width*zoom;
 PaintBox1->Height=kep->Height*zoom;
 PaintBox1->Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PaintBox1Paint(TObject *Sender)
{
 PaintBox1->Width=kep->Width*zoom;
 PaintBox1->Height=kep->Height*zoom;
 if(zoom==1)
    PaintBox1->Canvas->Draw(0,0,kep);
 else
    PaintBox1->Canvas->StretchDraw(TRect(0,0,kep->Width*zoom,kep->Height*zoom),kep);
}
//---------------------------------------------------------------------------
void TForm1::showbitmap(int ix,int pal,AnsiString idx,int offs,bool exp){
   unsigned __int16 wh,hh,_16; int bpp,dir,i,j,k,l; unsigned char ch,c;
   int x,y,*c1,*c2,b; unsigned __int16 d1; unsigned char* p;
   int wb,base,wb2; unsigned __int32 _32;
   TColor col=(TColor)0; AnsiString st;
   TMemoryStream* ms2=new TMemoryStream;
   TMemoryStream* ms_pal=new TMemoryStream;
   TMemoryStream* ms_exp;
   TMemoryStream* ms=ms_res[ix];
   if(exp) ms_exp=new TMemoryStream;
   ms->Seek(0,soFromBeginning);
   ms->Read(&hh,2);
   int cmeth;
   if(hh==0){
      if(!exp){ kep->Width=0; kep->Height=0; }
      wh=hh=bpp=cmeth=0;
      goto Vege;
   }
   ms->Read(&wh,2);
   if(!exp){kep->Width=wh; kep->Height=hh;}
//   ShowMessage(IntToStr(wh)+"x"+IntToStr(hh));
   ms->Read(&_16,2);
   /*ShowMessage*///Form1->Caption=(IntToHex(_16,4));
   int bpp2;
   bpp2=(_16>>12)&0xF;
   cmeth=(_16>>8)&0xF+((_16&0xF)<<4);
   switch(bpp2){
     case 0x0: bpp=1; break;
     case 0xB: bpp=4; break;
     case 0xF: bpp=8; break;
     default: ShowMessage("Ismeretlen bitmlysg! "+IntToHex(bpp2,1)); goto Vege;
   }
   ms2->SetSize((wh*bpp+7)/8*hh);
   switch(cmeth){
      case 0: dir=0;
      for(i=0;i<poprec[/*ListBox1->ItemIndex*/ix].len-6;i++){
         ms->Read(&ch,1);
         ms2->Write(&ch,1);
      }
      break;
      case 1: dir=0;
      unrle(ms,ms2,poprec[/*ListBox1->ItemIndex*/ix].len-6);
      break;
      case 2: dir=1;
      unrle(ms,ms2,poprec[/*ListBox1->ItemIndex*/ix].len-6);
      break;
      case 3: dir=0;
      unlzg(ms,ms2,poprec[/*ListBox1->ItemIndex*/ix].len-6);
      break;
      case 4: dir=1;
      unlzg(ms,ms2,poprec[/*ListBox1->ItemIndex*/ix].len-6);
      break;
      case 0x13: dir=0;
      unlzgrle(ms,ms2,poprec[/*ListBox1->ItemIndex*/ix].len-6);
      break;
      default: ShowMessage("Ismeretlen tmrts! "+IntToHex(cmeth,2)); goto Vege;
   }
   if(dir) {c1=&x,c2=&y,d1=hh;} else {c1=&y,c2=&x,d1=(wh*bpp+7)/8;}
//   kep->PixelFormat=pf24bit;
   b=8/bpp;
   for(i=0;i<nor;i++){
      if(poprec[i].id==pal&&(ver==1||AnsiString(poprec[i].idx)==idx)) break;
   }
   if(i<nor){
      TMemoryStream* ms=ms_res[i];
      if(exp){
         ms_pal->SetSize(4<<bpp);
         ms->Seek(offs,soFromBeginning);
         for(i=0;i<1<<bpp;i++){
            ms->Read(&col,3);
            col<<=2;
            ms_pal->Write((char*)(&col)+2,1);
            ms_pal->Write((char*)(&col)+1,1);
            ms_pal->Write((char*)(&col)+0,1);
            ms_pal->Write((char*)(&col)+3,1);
         }
      }else{
         switch(sm){
            case 'v':
            ms_pal->SetSize(4<<bpp);
            ms->Seek(offs,soFromBeginning);
            for(i=0;i<1<<bpp;i++){
               ms->Read(&col,3);
               col<<=2;
               ms_pal->Write(&col,4);
            }
            break;
            case 'e':
            ms_pal->SetSize(16<<bpp);
            ms->Seek(68,soFromBeginning);
            for(i=0;i<2;i++){
               for(j=0;j<2;j++){
                  for(k=0;k<8;k++){
                     ms->Read(&ch,1);
                     for(l=0;l<2;l++){
                        col=egacols[(ch>>4)&0xF];
                        ms_pal->Write(&col,4);
                        ch<<=4;
                     }
                  }
               }
            }
            break;
            case 'c':
            ms_pal->SetSize(16<<bpp);
            ms->Seek(52,soFromBeginning);
            for(i=0;i<2;i++){
               for(j=0;j<2;j++){
                  for(k=0;k<4;k++){
                     ms->Read(&ch,1);
                     for(l=0;l<4;l++){
                        col=cgacols[(ch>>6)&0x3];
                        ms_pal->Write(&col,4);
                        ch<<=2;
                     }
                  }
               }
            }
            break;
         }
         if(bpp==1) ShowMessage("b/w");
      }
   }else{
      for(j=0;j<(sm=='v'?1:4);j++)
      for(i=0;i<(1<<bpp);i++){
         col=(TColor)((i<<(8-bpp))*0x010101);
         ms_pal->Write(&col,4);
      }
   }
//   if(exp)
   wb=(wh*bpp+7)>>3;
   if(exp){
      wb2=(wb+3)&~3;
      int bmpsize=0x36+(4<<bpp)+wb2*hh;
      //BITMAPINFOHEADER
      ms_exp->SetSize(bmpsize);
      memset(ms_exp->Memory,0,bmpsize);
      ms_exp->Write("BM",2);
      _32=bmpsize; ms_exp->Write(&_32,4);
      _32=0; ms_exp->Write(&_32,4);
      _32=0x36+(4<<bpp); ms_exp->Write(&_32,4);
      _32=40; ms_exp->Write(&_32,4);
      _32=wh; ms_exp->Write(&_32,4);
      _32=hh; ms_exp->Write(&_32,4);
      _16=1; ms_exp->Write(&_16,2);
      _16=bpp; ms_exp->Write(&_16,2);
      _32=0; ms_exp->Write(&_32,4);
      _32=wb2*hh; ms_exp->Write(&_32,4);
      _32=0xEC4; ms_exp->Write(&_32,4);
      _32=0xEC4; ms_exp->Write(&_32,4);
      _32=0; ms_exp->Write(&_32,4);
      _32=0; ms_exp->Write(&_32,4);
      ms_exp->Write(ms_pal->Memory,4<<bpp);
      base=0x36+(4<<bpp);
   }
   if(!exp) kep->PixelFormat=pf24bit;
   for(y=0;y<hh;y++){
      if(!exp) p=(unsigned char*)kep->ScanLine[y];
      if(exp) ms_exp->Seek(base+(hh-1-y)*wb2,soFromBeginning);
      for(x=0;x<wb;x++){
         ch=((unsigned char*)(ms2->Memory))[(*c1)*d1+(*c2)];
         if(exp)
            ms_exp->Write(&ch,1);
         else{
            for(i=0;i<b&&x*b+i<wh;i++){
   //            c=ch&((1<<bpp)-1); ch>>=bpp;
               c=ch>>(8-bpp); ch<<=bpp;
   //            *(p++)=c; *(p++)=c; *(p++)=c;
   //            kep->Canvas->Pixels[x*b+(b-1)-i][y]=((TColor*)ms_pal->Memory)[c];
               switch(sm){
                  case 'v':
                  col=((TColor*)ms_pal->Memory)[c];
                  break;
                  case 'e':
                  col=((TColor*)ms_pal->Memory)[c+((x*b+i)&1)*(2<<bpp)+(y&1)*(1<<bpp)];
                  break;
                  case 'c':
                  col=((TColor*)ms_pal->Memory)[c+((x*b+i)&1)*(2<<bpp)+(y&1)*(1<<bpp)];
                  break;
               }
               *(p++)=(col>>16)&0xFF;
               *(p++)=(col>>8)&0xFF;
               *(p++)=col&0xFF;
            }
         }
      }
   }
   Vege:
   delete ms2;
   if(exp){
      AnsiString s;
/*      s=mi2->ReadString(treat,
         ((ver!=1)?AnsiString(poprec[ix].idx)+",":AnsiString(""))+IntToStr(poprec[ix].id),"");
      if(s=="") s="unknown\\"+UpperCase(ExtractFileName(OpenDialog1->FileName))+
         ((ver!=1)?"\\"+AnsiString(poprec[ix].idx):AnsiString(""))+"\\res"+IntToStr(poprec[ix].id)+".bmp";*/
      s=getexpfilename(poprec[ix].idx,poprec[ix].id,".bmp");
      s=exppath+s;
      mkdir_recursive(ExtractFilePath(s));
      ms_exp->SaveToFile(s);
      delete ms_exp;
   }
   st.printf(" %d*%d, %d bpp, %s%s",wh,hh,bpp,comp[(_16>>8)&0xF],comp2[_16&0xF]);
   StatusBar1->SimpleText=StatusBar1->SimpleText+st;
}
//---------------------------------------------------------------------------
void TForm1::unrle(TMemoryStream* ms_in,TMemoryStream* ms_out,int size){
   int p=0,i; signed char ch; unsigned char ch2;
   while(p<size){
      ms_in->Read(&ch,1);
      p++;
      if(ch<0){
         ms_in->Read(&ch2,1);
         p++;
         for(i=0;i<-ch;i++){
            ms_out->Write(&ch2,1);
         }
      }else{
         for(i=0;i<=ch;i++){
            ms_in->Read(&ch2,1);
            ms_out->Write(&ch2,1);
            p++;
         }
      }
   }
// ms_out->SaveToFile(ExtractFilePath(Application->ExeName)+"dump");
}
//---------------------------------------------------------------------------
void TForm1::unlzg(TMemoryStream* ms_in,TMemoryStream* ms_out,int size){
 int p=0,r,s,i,a,j; unsigned char ch,ch2; unsigned __int16 _16;
 ms_out->SetSize(ms_out->Size+1024);
 ms_out->Seek(0,soFromBeginning);
 ch=0;
 for(i=0;i<1024;i++) ms_out->Write(&ch,1);
 while(p<size){
    ms_in->Read(&ch,1);
    p++;
    for(i=0;i<8&&p<size;i++){
       if(ch&1){
          ms_in->Read(&ch2,1);
          ms_out->Write(&ch2,1);
          p++;
       }else{
          ms_in->Read(&ch2,1);
          _16=ch2<<8;
          ms_in->Read(&ch2,1);
          _16+=ch2;
          r=(_16>>10)+3;
          s=(_16&1023)+66;
          a=(ms_out->Position&(~1023))+(s&1023);//
//          a=(ms_out->Position-s)&1023;
          if(a>=ms_out->Position) a-=1024;//
          for(j=0;j<r;j++){
             ms_out->Write(((char*)ms_out->Memory)+a+j,1);//
//             ms_out->Write(((char*)ms_out->Memory)+ms_out->Position-a,1);
          }
          p+=2;
       }
       ch>>=1;
    }
 }
// ms_out->SaveToFile(ExtractFilePath(Application->ExeName)+"dump");
// ms_out->Seek(0,soFromBeginning);
// ms_out->Write((char*)ms_out->Memory+1024,ms_out->Size-1024);
 for(i=0;i<ms_out->Size-1024;i++){
    ((char*)ms_out->Memory)[i]=((char*)ms_out->Memory)[i+1024];
 }
 ms_out->SetSize(ms_out->Size-1024);
// ms_out->SaveToFile(ExtractFilePath(Application->ExeName)+"dump");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ActionVga1Execute(TObject *Sender)
{
 sm='v'; ActionVga1->Checked=true; vga1->Checked=true;
 ListBox1Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ActionEga1Execute(TObject *Sender)
{
 sm='e'; ActionEga1->Checked=true; ega1->Checked=true;
 ListBox1Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ActionCga1Execute(TObject *Sender)
{
 sm='c'; ActionCga1->Checked=true; cga1->Checked=true;
 ListBox1Click(Sender);
}
//---------------------------------------------------------------------------
void TForm1::showpalettepop1(int ix,bool exp){
 TMemoryStream* ms=ms_res[ix];
 if(exp) {showbinary(ix,true); return;}
 int i,j,k,l,x,y; TColor c; unsigned char ch;
    kep->Width=256;
    kep->Height=16;
 switch(sm){
    case 'v':
    ms->Seek(4,soFromBeginning);
    for(i=0;i<16;i++){
       ms->Read((char*)(&c)+0,1);
       ms->Read((char*)(&c)+1,1);
       ms->Read((char*)(&c)+2,1);
       kep->Canvas->Brush->Color=(TColor)(c<<2);
       kep->Canvas->Rectangle(i*16,0,i*16+16,16);
    }
    break;
    case 'e':
    ms->Seek(68,soFromBeginning);
    for(i=0;i<2;i++){
       for(j=0;j<2;j++){
          for(k=0;k<8;k++){
             ms->Read(&ch,1);
             for(l=0;l<2;l++){
                c=egacols[(ch>>4)&0xF];
                for(x=0;x<16;x+=2){
                   for(y=0;y<16;y+=2){
                      kep->Canvas->Pixels[(k*2+l)*16+x+j][y+i]=c;
                   }
                }
                ch<<=4; 
             }
          }
       }
    }
    break;
    case 'c':
    ms->Seek(52,soFromBeginning);
    for(i=0;i<2;i++){
       for(j=0;j<2;j++){
          for(k=0;k<4;k++){
             ms->Read(&ch,1);
             for(l=0;l<4;l++){
                c=cgacols[(ch>>6)&0x3];
                for(x=0;x<16;x+=2){
                   for(y=0;y<16;y+=2){
                      kep->Canvas->Pixels[(k*4+l)*16+x+j][y+i]=c;
                   }
                }
                ch<<=2;
             }
          }
       }
    }
    break;
 }
}
//---------------------------------------------------------------------------
void TForm1::showpaletteraw(int ix,bool exp){
 TMemoryStream* ms=ms_res[ix];
 if(exp) {showbinary(ix,true); return;}
   int i,j; TColor c=(TColor)0;
   ms->Seek(0,soFromBeginning);
   kep->Width=256;
   kep->Height=poprec[ix].len/48*16;
   for(i=0;i<poprec[ix].len/48;i++){
      for(j=0;j<16;j++){
         ms->Read((char*)(&c)+0,1);
         ms->Read((char*)(&c)+1,1);
         ms->Read((char*)(&c)+2,1);
         kep->Canvas->Brush->Color=TColor(c<<2);
         kep->Canvas->Rectangle(j*16,i*16,j*16+16,i*16+16);
      }
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ActionPrince1Execute(TObject *Sender)
{
 ver=1; ActionPrince1->Checked=true; Prince1->Checked=true;
 ActionEga1->Enabled=true;
 ActionCga1->Enabled=true;
 OpenDialog1->FilterIndex=1;
 SaveDialog1->FilterIndex=1;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ActionPrince2Execute(TObject *Sender)
{
 ver=2; ActionPrince2->Checked=true; Prince2->Checked=true;
 ActionVga1Execute(Sender);
 ActionEga1->Enabled=false;
 ActionCga1->Enabled=false;
 OpenDialog1->FilterIndex=1;
 SaveDialog1->FilterIndex=1;
}
//---------------------------------------------------------------------------
void TForm1::opendat1(){
    __int32 sa; __int16 si;
    int i; AnsiString s;
    TMemoryStream* ms=new TMemoryStream;
    ms->LoadFromFile(filename);
/*    for(i=0;i<MAX_NUMBER_OF_RES;i++){
       if(ms_res[i]){ delete ms_res[i]; ms_res[i]=NULL; }
    }*/
    delall();
    ms->Seek(0,soFromBeginning);
//    ListBox1->Clear();
    ms->Read(&sa,4);
    ms->Read(&si,2);
    ms->Seek(sa,soFromBeginning);
    ms->Read(&nor,2);
    createall(nor);
    for(i=0;i<nor;i++){
//       ms->Read(&(poprec[i]),8);
       ms->Read(&(poprec[i].id),2);
       ms->Read(&(poprec[i].sa),4);
       poprec[i].len=0;
       ms->Read(&(poprec[i].len),2);
       poprec[i].idx[0]=0;
/*       s.printf("id=%d, size=%d",poprec[i].id,poprec[i].len);
       ListBox1->Items->Add(s);*/
//       ms_res[i]=new TMemoryStream();
       ms_res[i]->SetSize(poprec[i].len);
       ms_res[i]->Write((char*)ms->Memory+poprec[i].sa+1,poprec[i].len);
    }
    delete ms;
}
//---------------------------------------------------------------------------
void TForm1::opendat2(){
    __int32 sa; __int16 si,n,m;
    int i,j,p=0; AnsiString s,idx[16]; unsigned __int32 _32;
    unsigned __int16 sa2[16]; char ix[5]={0,0,0,0,0};
    TMemoryStream* ms=new TMemoryStream();
    ms->LoadFromFile(filename);
/*    for(i=0;i<MAX_NUMBER_OF_RES;i++){
       if(ms_res[i]){ delete ms_res[i]; ms_res[i]=NULL; }
    }*/
    delall();
    ms->Seek(0,soFromBeginning);
//    ListBox1->Clear();
    ms->Read(&sa,4);
    ms->Read(&si,2);
    ms->Seek(sa,soFromBeginning);
    ms->Read(&n,2);
    for(i=0;i<n;i++){
       ms->Read(ix,4);
//       idx[i][4]=0;
       ms->Read(&(sa2[i]),2);
       for(j=3;j>=0;j--){
          if(ix[j]) idx[i]+=AnsiString(ix+j,1);
       }
    }
    nor=0;
    for(i=0;i<n;i++){
       ms->Seek(sa+sa2[i],soFromBeginning);
       ms->Read(&m,2);
       nor+=m;
    }
    createall(nor);
    for(i=0;i<n;i++){
       ms->Seek(sa+sa2[i],soFromBeginning);
       ms->Read(&m,2);
       for(j=0;j<m;j++){
//          ms->Read(&(poprec[p]),11);
          ms->Read(&(poprec[p].id),2);
          ms->Read(&(poprec[p].sa),4);
          poprec[p].len=0;
          ms->Read(&(poprec[p].len),2);
          ms->Read(&(poprec[p].flags),3);
//          ms->Read(&_32,3);
          strcpy(poprec[p].idx,idx[i].c_str());
/*          s.printf("index=%s, id=%d, size=%d",poprec[p].idx,poprec[p].id,poprec[p].len);
          ListBox1->Items->Add(s);*/
//          ms_res[p]=new TMemoryStream();
          ms_res[p]->SetSize(poprec[p].len);
          ms_res[p]->Write((char*)ms->Memory+poprec[p].sa+1,poprec[p].len);
          p++;
       }
    }
//    nor=p;
    delete ms;
}
//---------------------------------------------------------------------------
void TForm1::showpalettepop2(int ix,bool exp){
 TMemoryStream* ms=ms_res[ix];
 if(exp) {showbinary(ix,true); return;}
   int i,j; TColor c;
   ms->Seek(7,soFromBeginning);
   kep->Width=256;
   kep->Height=(poprec[ix].len-7)/48*16;
   for(i=0;i<(poprec[ix].len-7)/48;i++){
      for(j=0;j<16;j++){
         ms->Read((char*)(&c)+0,1);
         ms->Read((char*)(&c)+1,1);
         ms->Read((char*)(&c)+2,1);
         kep->Canvas->Brush->Color=TColor(c<<2);
         kep->Canvas->Rectangle(j*16,i*16,j*16+16,i*16+16);
      }
   }
}
//---------------------------------------------------------------------------
void TForm1::unlzgrle(TMemoryStream* ms_in,TMemoryStream* ms_out,int size){
   TMemoryStream* ms_mid=new TMemoryStream;
   unsigned __int16 ln,si; int p=0,/*pp=0,*/i=0,en;
   en=ms_in->Position+size;
//   Form1->Caption=Form1->Caption+" Lines:";
   Ujra:
//   ShowMessage(ms_in->Position);
   ms_in->Read(&ln,2);
   ms_mid->SetSize(ln);
   ms_mid->Seek(0,soFromBeginning);
   unlzg2(ms_in,ms_mid,ln);
   ms_mid->Seek(0,soFromBeginning);
   p=0;
   do{
      ms_mid->Read(&si,2); p+=2;
      unrle2(ms_mid,ms_out,si); p+=si;
//      i++;
//      ms_out->Write(&i,1);
   }while(p<ln);
//   Form1->Caption=Form1->Caption+" "+IntToStr(i);
//   pp+=p;
//   ms_mid->SaveToFile(ExtractFilePath(Application->ExeName)+"dump.m"+IntToStr(++i));
   if(ms_in->Position<en) goto Ujra;
   delete ms_mid;
//   ms_out->SaveToFile(ExtractFilePath(Application->ExeName)+"dump.o");
}
//---------------------------------------------------------------------------
void TForm1::unrle2(TMemoryStream* ms_in,TMemoryStream* ms_out,int size){
   int p=0,i; unsigned char ch; unsigned char ch2;
   while(p<size){
      ms_in->Read(&ch,1);
      p++;
      if(ch&0x80){
         ms_in->Read(&ch2,1);
         p++;
         for(i=0;i<=(ch&0x7F);i++){
            ms_out->Write(&ch2,1);
         }
      }else{
         for(i=0;i<=ch;i++){
            ms_in->Read(&ch2,1);
            ms_out->Write(&ch2,1);
            p++;
         }
      }
   }
// ms_out->SaveToFile(ExtractFilePath(Application->ExeName)+"dump");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ActionReload1Execute(TObject *Sender)
{
 delete mi;
 mi=new TMemIniFile(ExtractFilePath(Application->ExeName)+"dat.ini");
 ListBox1Click(Sender);
}
//---------------------------------------------------------------------------

void TForm1::unlzg2(TMemoryStream* ms_in,TMemoryStream* ms_out,int size){
 int p=0,r,s,i,a,j/*,po*/; unsigned char ch,ch2; unsigned __int16 _16;
// po=ms_out->Position;
 ch=0;
 for(i=0;i<1024;i++) ms_out->Write(&ch,1);
 while(p<size){
    ms_in->Read(&ch,1);
    for(i=0;i<8&&p<size;i++){
       if(ch&1){
          ms_in->Read(&ch2,1);
          ms_out->Write(&ch2,1);
          p++;
       }else{
          ms_in->Read(&ch2,1);
          _16=ch2<<8;
          ms_in->Read(&ch2,1);
          _16+=ch2;
          r=(_16>>10)+3;
          s=(_16&1023)+66;
          a=(ms_out->Position&(~1023))+(s&1023);//
//          a=(ms_out->Position/*-po*/-s)&1023;
          if(a>=ms_out->Position) a-=1024;//
          for(j=0;j<r;j++){
             ch2=((char*)ms_out->Memory)[/*ms_out->Position+*/a+j];//
//             ch2=((char*)ms_out->Memory)[ms_out->Position-a];
             ms_out->Write(&ch2,1);
             p++;
          }
       }
       ch>>=1;
    }
 }
// ms_out->SaveToFile(ExtractFilePath(Application->ExeName)+"dump");
// ms_out->Seek(0,soFromBeginning);
// ms_out->Write((char*)ms_out->Memory+1024,ms_out->Size-1024);
 for(i=/*po*/0;i<ms_out->Size-1024;i++){
    ((char*)ms_out->Memory)[i]=((char*)ms_out->Memory)[i+1024];
 }
 ms_out->SetSize(ms_out->Size-1024);
// ms_out->Seek(po+size,soFromBeginning);
// ms_out->SaveToFile(ExtractFilePath(Application->ExeName)+"dump");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ActionZoomIn1Execute(TObject *Sender)
{
 if(zoom<10) zoom++; PaintBox1->Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ActionZoomOut1Execute(TObject *Sender)
{
 if(zoom>1) zoom--; PaintBox1->Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ActionExportAll1Execute(TObject *Sender)
{
 int i;
 exppath=ExtractFilePath(Application->ExeName);
 if(InputQuery("Exportls","",exppath)){
    if(exppath[exppath.Length()]!='\\') exppath+="\\";
    for(i=0;i<nor;i++){
       show(i,true);
    }
 }
}
//---------------------------------------------------------------------------

void mkdir_recursive(AnsiString s){
   AnsiString s2=ExtractFilePath(s.SubString(1,s.Length()-1));
   if(GetFileAttributes(s2.c_str())==0xFFFFFFFF){
      mkdir_recursive(s2);
   }
   CreateDir(s);
}
//---------------------------------------------------------------------------

void TForm1::showbinary(int ix,bool exp){
   if(!exp){
      kep->Width=0; kep->Height=0;
      return;
   }
   TMemoryStream* ms_exp=new TMemoryStream;
   AnsiString s;
//   ms->Seek(poprec[ix].sa+1,soFromBeginning);
   ms_exp->SetSize(poprec[ix].len);
   ms_exp->Write(ms_res[ix]->Memory,poprec[ix].len);
/*   s=mi2->ReadString(treat,
      ((ver!=1)?AnsiString(poprec[ix].idx)+",":AnsiString(""))+IntToStr(poprec[ix].id),"");
   if(s=="") s="unknown\\"+UpperCase(ExtractFileName(OpenDialog1->FileName))+
      ((ver!=1)?"\\"+AnsiString(poprec[ix].idx):AnsiString(""))+"\\res"+IntToStr(poprec[ix].id)+".bin";*/
   s=getexpfilename(poprec[ix].idx,poprec[ix].id,".bin");
   s=exppath+s;
   mkdir_recursive(ExtractFilePath(s));
   ms_exp->SaveToFile(s);
   delete ms_exp;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ActionImportAll1Execute(TObject *Sender)
{
 exppath=ExtractFilePath(Application->ExeName);
 if(InputQuery("Importls","",exppath)){
    if(exppath[exppath.Length()]!='\\') exppath+="\\";
    int n,i,ix=0; //unsigned __int32 _32=0,sk; unsigned __int16 _16=0;
//    TStringList* sl1=new TStringList;
    TStringList* sl2=new TStringList;
    AnsiString na,va;
//    mi->ReadSectionValues(treat,sl1);
    mi2->ReadSectionValues(treat,sl2);
    n=sl2->Count;
//    delete sl2;
    nor=0;
/*    for(i=0;i<MAX_NUMBER_OF_RES;i++){
       if(ms_res[i]){ delete ms_res[i]; ms_res[i]=NULL; }
    }*/
    delall();
/*    ms->SetSize(0);
    ms->Seek(0,soFromBeginning);
    ms->Write(&_32,4);
    ms->Write(&_16,2);*/
    nor=0;
    for(i=0;i<n;i++){
       na=sl2->Names[i];
       va=exppath+sl2->Values[na];
       if(GetFileAttributes(va.c_str())!=0xFFFFFFFF){
          nor++;
       }
    }
    createall(nor);
    for(i=0;i<n;i++){
       na=sl2->Names[i];
       va=exppath+sl2->Values[na];
       if(GetFileAttributes(va.c_str())!=0xFFFFFFFF){
          ms_res[ix]=new TMemoryStream;
          import(na,va,ix++);
       }
    }
/*    sk=ms->Position;
    if(ver==1){
       ms->Write(&nor,2);
       for(i=0;i<nor;i++){
          ms->Write(&(poprec[i]),8);
       }
    }else{
       AnsiString idx[16]; int noi=0,j; unsigned __int16 sk2;
       int noi2[16];
       for(i=0;i<nor;i++){
          for(j=0;j<noi;j++){
             if(idx[j]==poprec[i].idx) break;
          }
          if(j==noi){ idx[noi]=poprec[i].idx; noi2[noi]=0; noi++; }
          noi2[j]++;
       }
       ms->Write(&noi,2);
       _16=0;
       for(i=0;i<noi;i++){
          _32=0;
          for(j=0;j<idx[i].Length();j++){
             _32=(_32<<8)+idx[i][j+1];
          }
          ms->Write(&_32,4);
          ms->Write(&_16,2);
       }
       for(i=0;i<noi;i++){
          sk2=ms->Position-sk;
          ms->Seek(sk+i*6+6,soFromBeginning);
          ms->Write(&sk2,2);
          ms->Seek(sk+sk2,soFromBeginning);
          ms->Write(noi2+i,2);
          for(j=0;j<nor;j++){
             if(idx[i]==poprec[j].idx) ms->Write(&(poprec[j]),11);
          }
       }
    }
    _16=ms->Size-sk;
    ms->Seek(0,soFromBeginning);
    ms->Write(&sk,4);
    ms->Write(&_16,2);*/
//    delete sl1;
    delete sl2;
    showlist();
 }
}
//---------------------------------------------------------------------------
void TForm1::import(AnsiString id,AnsiString file,int ix){
 AnsiString s,s2,s3; int /*sk,sk2,*/p,i; unsigned char /*cs=255,*/ch;
 TMemoryStream* ms_imp=new TMemoryStream;
 TMemoryStream* ms=ms_res[ix];
 s=mi->ReadString(treat,
    id,"binary");
// sk=ms->Position;
// ms->Write(&cs,1);
 p=s.Pos(","); if(p==0) p=s.Length()+1;
 s2=s.SubString(1,p-1);
 if(com==0||s2=="binary"||s2=="palettepop1"||s2=="palettepop2"||s2=="paletteraw"){
    ms_imp->LoadFromFile(file);
 }else if(s2=="image"){
    importbitmap(ms_imp,file);
 }else if(s2=="text"){
    s3=s.SubString(p+1,s.Length()-p);
    importtext(ms_imp,file,s3.Pos("4")!=0,s3.Pos("l")!=0);
 }else{
    ShowMessage("Ismeretlen tpus "+s2);
 }
 ms_imp->Seek(0,soFromBeginning);
/* for(i=0;i<ms_imp->Size;i++){
    ms_imp->Read(&ch,1);
    cs-=ch;
 }*/
 ms->SetSize(ms_imp->Size);
 ms->Seek(0,soFromBeginning);
 ms->Write(ms_imp->Memory,ms_imp->Size);
/* sk2=ms->Position;
 ms->Seek(sk,soFromBeginning);
 ms->Write(&cs,1);
 ms->Seek(sk2,soFromBeginning);*/
 if(ver==1){
    poprec[ix].id=StrToInt(id);
    poprec[ix].idx[0]=0;
 }else{
    p=id.Pos(",");
    strcpy(poprec[ix].idx,id.SubString(1,p-1).c_str());
    poprec[ix].id=StrToInt(id.SubString(p+1,id.Length()-p));
 }
// poprec[nor].sa=sk;
 poprec[ix].len=ms_imp->Size;
// nor++;
 delete ms_imp;
}
//---------------------------------------------------------------------------
void TForm1::importbitmap(TMemoryStream* ms_imp,AnsiString file){
/*   // Egyelre egy res kpet rak be
   unsigned char dummy[]={0x01,0x00,0x01,0x00,0x00,0x00,0x00};
   ms_imp->SetSize(sizeof(dummy));
   ms_imp->Seek(0,soFromBeginning);
   ms_imp->Write(dummy,sizeof(dummy));*/
   int bpp,x,y,wh,hh,wb,wb2,bpp2,base,si,mini,minsi,i,noc;
   unsigned char ch; unsigned __int16 _16;
   TMemoryStream* ms_bmp=new TMemoryStream;
   ms_bmp->LoadFromFile(file);
   if(*(unsigned __int16*)ms_bmp->Memory!='BM'){
      ShowMessage("Ez nem egy BMP kp! "+file);
      delete ms_bmp; return;
   }
   bpp=*(unsigned __int16*)((unsigned char*)ms_bmp->Memory+0x1C);
   switch(bpp){
      case 1: bpp2=0x0; break;
      case 4: bpp2=0xB; break;
      case 8: bpp2=0xF; break;
      default: ShowMessage("Ismeretlen bitmlysg! "+IntToStr(bpp)+" bpp");
      delete ms_bmp; return;
   }
   typedef TMemoryStream* Tmsp;
   Tmsp ms_lr=new TMemoryStream;
   Tmsp ms_ud=new TMemoryStream;
   Tmsp ms_rle_lr=new TMemoryStream;
   Tmsp ms_rle_ud=new TMemoryStream;
   Tmsp ms_lzg_lr=new TMemoryStream;
   Tmsp ms_lzg_ud=new TMemoryStream;
   Tmsp ms_all[]={ms_lr,ms_rle_lr,ms_rle_ud,ms_lzg_lr,ms_lzg_ud};
   wh=*(unsigned __int32*)((unsigned char*)ms_bmp->Memory+0x12);
   hh=*(unsigned __int32*)((unsigned char*)ms_bmp->Memory+0x16);
   base=0x36+(4<<bpp);
   wb=(wh*bpp+7)>>3;
   wb2=(wb+3)&~3;
   si=wb*hh;
   ms_lr->SetSize(si);
   ms_ud->SetSize(si);
   for(y=0;y<hh;y++){
      ms_bmp->Seek(base+(hh-1-y)*wb2,soFromBeginning);
      for(x=0;x<wb;x++){
         ms_bmp->Read(&ch,1);
         ((unsigned char*)(ms_lr->Memory))[y*wb+x]=ch;
         ((unsigned char*)(ms_ud->Memory))[x*hh+y]=ch;
      }
   }
   noc=1;
   if(bpp!=8){
      if(com>=2){
         noc=3;
         rle(ms_lr,ms_rle_lr);
         rle(ms_ud,ms_rle_ud);
         if(com>=3){
            noc=5;
            ms_lr->Seek(0,soFromBeginning);
            lzg(ms_lr,ms_lzg_lr);
            ms_ud->Seek(0,soFromBeginning);
            lzg(ms_ud,ms_lzg_ud);
         }
      }
      mini=0; minsi=ms_all[0]->Size;
      for(i=1;i<noc;i++){
         if(ms_all[i]->Size<minsi){ mini=i; minsi=ms_all[i]->Size; }
      }
   }else{
      lzgrle(ms_lr,ms_lzg_lr,wh);
      mini=3; minsi=ms_lzg_lr->Size;
   }
   ms_imp->Write(&hh,2);
   ms_imp->Write(&wh,2);
   _16=(bpp2<<12)+(mini<<8);
   if(bpp==8) _16|=0x1;
   ms_imp->Write(&_16,2);
   ms_imp->Write(ms_all[mini]->Memory,minsi);
   Vege:
   delete ms_bmp;
   delete ms_lr;
   delete ms_ud;
   delete ms_rle_lr;
   delete ms_rle_ud;
   delete ms_lzg_lr;
   delete ms_lzg_ud;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ActionMentes1Execute(TObject *Sender)
{
 if(SaveDialog1->Execute()){
    unsigned __int32 _32;
    unsigned __int16 _16;
    unsigned char ch,cs;
    int i,b,sk,sk2;
    TMemoryStream* ms=new TMemoryStream;
    ms->SetSize(0);
    ms->Seek(0,soFromBeginning);
    ms->Write(&_32,4);
    ms->Write(&_16,2);
    for(i=0;i<nor;i++){
       cs=255;
       sk=ms->Position;
       poprec[i].sa=sk;
//       poprec[i].len=ms_res[i]->Size;
       ms->Write(&cs,1);
       ms_res[i]->Seek(0,soFromBeginning);
       for(b=0;b<ms_res[i]->Size;b++){
          ms_res[i]->Read(&ch,1);
          cs-=ch;
          ms->Write(&ch,1);
       }
       sk2=ms->Position;
       ms->Seek(sk,soFromBeginning);
       ms->Write(&cs,1);
       ms->Seek(sk2,soFromBeginning);
    }
    sk=ms->Position;
    if(ver==1){
       ms->Write(&nor,2);
       for(i=0;i<nor;i++){
//          ms->Write(&(poprec[i]),8);
          ms->Write(&(poprec[i].id),2);
          ms->Write(&(poprec[i].sa),4);
          ms->Write(&(poprec[i].len),2);
       }
    }else{
       AnsiString idx[16]; int noi=0,j; unsigned __int16 sk2;
       int noi2[16];
       for(i=0;i<nor;i++){
          for(j=0;j<noi;j++){
             if(idx[j]==poprec[i].idx) break;
          }
          if(j==noi){ idx[noi]=poprec[i].idx; noi2[noi]=0; noi++; }
          noi2[j]++;
       }
       ms->Write(&noi,2);
       _16=0;
       for(i=0;i<noi;i++){
          _32=0;
          for(j=0;j<idx[i].Length();j++){
             _32=(_32<<8)+idx[i][j+1];
          }
          ms->Write(&_32,4);
          ms->Write(&_16,2);
       }
       for(i=0;i<noi;i++){
          sk2=ms->Position-sk;
          ms->Seek(sk+i*6+6,soFromBeginning);
          ms->Write(&sk2,2);
          ms->Seek(sk+sk2,soFromBeginning);
          ms->Write(noi2+i,2);
          for(j=0;j<nor;j++){
             if(idx[i]==poprec[j].idx){
//                 ms->Write(&(poprec[j]),11);
                ms->Write(&(poprec[j].id),2);
                ms->Write(&(poprec[j].sa),4);
                ms->Write(&(poprec[j].len),2);
                ms->Write(&(poprec[j].flags),3);
             }
          }
       }
    }
    _16=ms->Size-sk;
    ms->Seek(0,soFromBeginning);
    ms->Write(&sk,4);
    ms->Write(&_16,2);
    ms->SaveToFile(SaveDialog1->FileName);
    delete ms;
 }
}
//---------------------------------------------------------------------------

void TForm1::rle(TMemoryStream* ms_in,TMemoryStream* ms_out){
  int adln; unsigned char ch,Ech,chc;
  ch=0; ms_out->Write(&ch,1);
  ms_in->Read(&ch,1); Ech=ch;
  adln=0;
  ms_out->Write(&ch,1);
  while(ms_in->Position<ms_in->Size){
     ms_in->Read(&ch,1);
     if(ch==Ech){
        if(((signed char*)ms_out->Memory)[adln]<0){
           if(((unsigned char*)ms_out->Memory)[adln]>0x80){
              ((signed char*)ms_out->Memory)[adln]--;
           }else{
              adln=ms_out->Position;
              chc=0; ms_out->Write(&chc,1);
              ms_out->Write(&ch,1);
           }
        }else{
           if(((unsigned char*)ms_out->Memory)[adln]){
              ((unsigned char*)ms_out->Memory)[adln]--;
              ms_out->Seek(-1,soFromCurrent);
           }else{
              ms_out->Seek(-2,soFromCurrent);
           }
           adln=ms_out->Position;
           chc=0xFE; ms_out->Write(&chc,1);
           ms_out->Write(&ch,1);
        }
     }else{
        if(((signed char*)ms_out->Memory)[adln]<0){
           adln=ms_out->Position;
           chc=0; ms_out->Write(&chc,1);
           ms_out->Write(&ch,1);
        }else{
           if(((unsigned char*)ms_out->Memory)[adln]<0x7F){
              ((signed char*)ms_out->Memory)[adln]++;
              ms_out->Write(&ch,1);
           }else{
              adln=ms_out->Position;
              chc=0; ms_out->Write(&chc,1);
              ms_out->Write(&ch,1);
           }
        }
     }
     Ech=ch;
  }
}
//---------------------------------------------------------------------------
void TForm1::lzg(TMemoryStream* ms_in,TMemoryStream* ms_out){
  int bi=0,i,skmin,skmax,ln,j,bestp,bestln,adln,pos,si; unsigned char ch;
  unsigned __int16 _16;
  TMemoryStream* ms_in2=new TMemoryStream;
  ch=0;
  for(i=0;i<1024;i++) ms_in2->Write(&ch,1);
  ms_in2->Write(ms_in->Memory,ms_in->Size);
  ms_in2->Seek(1024,soFromBeginning);
  si=ms_in2->Size;
  while(ms_in2->Position<ms_in2->Size){
     if(bi==0){ adln=ms_out->Position; ch=0x00; ms_out->Write(&ch,1); }
     skmin=ms_in2->Position-1024/*1023*/; skmax=ms_in2->Position-1/*3*/;
     pos=ms_in2->Position;
     bestp=-1; bestln=-1;
     for(i=skmin;i<=skmax;i++){
        for(j=0;/*i+j<pos&&*/j<66&&pos+j<si;j++){
           if( ((unsigned char*)ms_in2->Memory)[i+j]!=
               ((unsigned char*)ms_in2->Memory)[/*ms_in2->Position*/pos+j]) break;
        }
        ln=j;
        if(ln<3) ln=-1;
        if(ln>bestln){ bestln=ln; bestp=i; }
     }
     if(bestln>-1){
        _16=((bestln-3)<<10)+((bestp-66)&1023);
        ch=_16>>8; ms_out->Write(&ch,1);
        ch=_16&255; ms_out->Write(&ch,1);
        ms_in2->Seek(bestln,soFromCurrent);
     }else{
        ((unsigned char*)ms_out->Memory)[adln]|=1<<bi;
        ms_in2->Read(&ch,1);
        ms_out->Write(&ch,1);
     }
     bi++; if(bi==8) bi=0;
  }
//  ms_in2->SaveToFile("dump.in2");
//  ms_out->SaveToFile("dump.out");
  delete ms_in2;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::ActionCompressRaw1Execute(TObject *Sender)
{
 ActionCompressRaw1->Checked=true; CompressRaw1->Checked=true;
 com=0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ActionCompressMin1Execute(TObject *Sender)
{
 ActionCompressMin1->Checked=true; CompressMin1->Checked=true;
 com=1;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ActionCompressMed1Execute(TObject *Sender)
{
 ActionCompressMed1->Checked=true; CompressMed1->Checked=true;
 com=2;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ActionCompressMax1Execute(TObject *Sender)
{
 ActionCompressMax1->Checked=true; CompressMax1->Checked=true;
 com=3;
}
//---------------------------------------------------------------------------
void TForm1::lzgrle(TMemoryStream* ms_in,TMemoryStream* ms_out,int size){
   unsigned __int16 _16; int sk,sk2,sa;
   TMemoryStream* ms_mid=new TMemoryStream;
   sa=0;
   Ujra:
   ms_mid->SetSize(0);
   ms_mid->Seek(0,soFromBeginning);
   while(/*ms_mid->Size<16384*/ms_in->Position-sa+size</*28800*/29010&&ms_in->Position<ms_in->Size){
      _16=0;
      ms_mid->Write(&_16,2);
      sk=ms_mid->Position;
      rle2(ms_in,ms_mid,size);
      sk2=ms_mid->Position;
      _16=sk2-sk;
      ms_mid->Seek(sk-2,soFromBeginning);
      ms_mid->Write(&_16,2);
      ms_mid->Seek(sk2,soFromBeginning);
   }
   _16=ms_mid->Size;
   ms_out->Write(&_16,2);
   lzg(ms_mid,ms_out);
   sa=ms_in->Position;
   if(ms_in->Position<ms_in->Size) goto Ujra;
   delete ms_mid;
}
//---------------------------------------------------------------------------
void TForm1::rle2(TMemoryStream* ms_in,TMemoryStream* ms_out,int size){
  int adln,p=0; unsigned char ch,Ech,chc;
  adln=ms_out->Position;
  ms_in->Read(&ch,1); p++; Ech=ch;
  chc=ch?0:0x80; ms_out->Write(&chc,1);
  ms_out->Write(&ch,1);
  while(p<size){
     ms_in->Read(&ch,1); p++;
     if(ch==Ech){
        if(((unsigned char*)ms_out->Memory)[adln]&0x80){
           if(((unsigned char*)ms_out->Memory)[adln]<0xFF){
              ((unsigned char*)ms_out->Memory)[adln]++;
           }else{
              adln=ms_out->Position;
              chc=0; ms_out->Write(&chc,1);
              ms_out->Write(&ch,1);
           }
        }else{
           if(((unsigned char*)ms_out->Memory)[adln]){
              ((unsigned char*)ms_out->Memory)[adln]--;
              ms_out->Seek(-1,soFromCurrent);
           }else{
              ms_out->Seek(-2,soFromCurrent);
           }
           adln=ms_out->Position;
           chc=0x81; ms_out->Write(&chc,1);
           ms_out->Write(&ch,1);
        }
     }else{
        if(((unsigned char*)ms_out->Memory)[adln]&0x80){
           adln=ms_out->Position;
           chc=ch?0:0x80; ms_out->Write(&chc,1);
           ms_out->Write(&ch,1);
        }else{
           if(!ch) goto Nulla;
           if(((unsigned char*)ms_out->Memory)[adln]<0x7F){
              ((unsigned char*)ms_out->Memory)[adln]++;
              ms_out->Write(&ch,1);
           }else{ Nulla:
              adln=ms_out->Position;
              chc=ch?0:0x80; ms_out->Write(&chc,1);
              ms_out->Write(&ch,1);
           }
        }
     }
     Ech=ch;
  }
}
//---------------------------------------------------------------------------
void TForm1::showlist(){
   int i; AnsiString s;
   ListBox1->Clear();
   if(ver==1){
      for(i=0;i<nor;i++){
         s.printf("id=%d, size=%d",poprec[i].id,poprec[i].len);
         ListBox1->Items->Add(s);
      }
   }else{
      for(i=0;i<nor;i++){
         s.printf("index=%s, id=%d, size=%d",poprec[i].idx,poprec[i].id,poprec[i].len);
         ListBox1->Items->Add(s);
      }
   }
}
//---------------------------------------------------------------------------

void TForm1::showfont(int ix,bool exp){
   if(exp) {showbinary(ix,true); return;}
   const TColor colbg=clBlack,col0=clBlue,col1=clWhite;
   int const celwh=24,celhh=24;
   TMemoryStream* ms=ms_res[ix]; unsigned char chbeg,chend,ch;
   int i,x,y,x0,y0,wb,b; unsigned __int16 sa,wh,hh,_16;
   ms->Seek(0,soFromBeginning);
   ms->Read(&chbeg,1);
   ms->Read(&chend,1);
   kep->Width=0; kep->Height=0;
   kep->Canvas->Brush->Color=colbg;
   kep->Width=16*celwh; kep->Height=16*celhh;
   for(i=chbeg;i<=chend;i++){
      x0=(i&15)*celwh; y0=(i>>4)*celhh;
      ms->Seek(0xA+((i-chbeg)<<1),soFromBeginning);
      ms->Read(&sa,2);
      ms->Seek(sa,soFromBeginning);
      ms->Read(&hh,2);
      ms->Read(&wh,2);
      ms->Read(&_16,2);
      wb=(wh+7)>>3;
      for(y=0;y<hh;y++){
         for(x=0;x<wb;x++){
            ms->Read(&ch,1);
            for(b=0;b<8&&(x<<3)+b<wh;b++){
               kep->Canvas->Pixels[x0+(x<<3)+b][y0+y]=(ch&0x80)?col1:col0;
               ch<<=1;
            }
         }
      }
   }
}
//---------------------------------------------------------------------------

void TForm1::showtext(int ix,bool exp,bool fo,bool li){
//   if(exp) {showbinary(ix,true); return;}
   const TColor colbg=clWhite,colfg=clBlack;
   int i,wh=0,hh=0,wh2,y=0; unsigned __int8 n; /*unsigned*/ char ch;
   TStringList* list=new TStringList();
   TMemoryStream* ms=ms_res[ix];
   TMemoryStream* ms_mid=new TMemoryStream;
   AnsiString s="";
   if(fo) unfour(ms,ms_mid); else ms_mid->Write(ms->Memory,ms->Size);
   if(li) unlist(ms_mid,list); else list->Add(AnsiString((char*)ms_mid->Memory/*,ms_mid->Size*/));
   if(exp){
      s=getexpfilename(poprec[ix].idx,poprec[ix].id,".txt");
      s=exppath+s;
      mkdir_recursive(ExtractFilePath(s));
      list->SaveToFile(s);
      return;
   }
   kep->Width=0; kep->Height=0;
   kep->Canvas->Brush->Color=colbg;
   kep->Canvas->Pen->Color=colfg;
   for(i=0;i<list->Count;i++){
      s=list->Strings[i];
      if(s!=delim){
         wh2=kep->Canvas->TextWidth(s);
         if(wh2>wh) wh=wh2;
         hh+=kep->Canvas->TextHeight(s);
      }else{
         hh++;
      }
   }
   kep->Width=wh; kep->Height=hh;
   for(i=0;i<list->Count;i++){
      s=list->Strings[i];
      if(s!=delim){
         hh=kep->Canvas->TextHeight(s);
         kep->Canvas->TextOutA(0,y,s);
         y+=hh;
      }else{
         kep->Canvas->MoveTo(0,y);
         kep->Canvas->LineTo(wh,y);
         y++;
      }
   }
//   ShowMessage(list->Text);
/*   kep->Width=0; kep->Height=0;
   kep->Canvas->Brush->Color=colbg;
   kep->Canves->Pen->Color=colfg;
   kep->Width=16*celwh; kep->Height=16*celhh;*/
   delete list;
   delete ms_mid;
}
//---------------------------------------------------------------------------

void TForm1::unlist(TMemoryStream* ms_input,TStringList* sl_output){
   int i; unsigned __int8 n; char ch; AnsiString s="";
   ms_input->Seek(0,soFromBeginning);
   ms_input->Read(&n,1);
   i=0;
//   char* x=&ch; ShowMessage(IntToHex((int)x,8));
   do{
      ms_input->Read(&ch,1);
      switch(ch){
         case 0: i++;
         case 13: //list->Add(s);
         sl_output->Add(s);
         if(ch==0) sl_output->Add(delim);
         s=""; break;
         default: s+=AnsiString(&ch,1);
      }
   }while(i<n);

}
//---------------------------------------------------------------------------

void TForm1::unfour(TMemoryStream* ms_input,TMemoryStream* ms_output){
//   TMemoryStream* ms_hf=new TMemoryStream;

   TMemoryStream* ms_hf=new TMemoryStream;
   ms_hf->LoadFromFile(ExtractFilePath(Application->ExeName)+"PR2HFMAN.bin");
   char hf[128];
   ms_hf->Seek(0,soFromBeginning);
   ms_hf->Read(hf,128);
   delete ms_hf;

   bitstack bs;
   unsigned __int16 n; int v,bi,i=0;
//   ms_hf->LoadFromFile(ExtractFilePath(Application->ExeName)+"PR2HFMAN.bin");
   ms_input->Seek(0,soFromBeginning);
   ms_input->Read(&n,2);
   ms_output->SetSize(n);
   ms_output->Seek(0,soFromBeginning);
   v=bs.read(ms_input,2);
   bi=v+5;
   while(i<n){
      v=bs.read(ms_input,4);
      if(v==0) v=bs.read(ms_input,bi);
      ms_output->Write(/*(char*)ms_hf->Memory+v*/hf+v,1);
      i++;
   }
//   delete ms_hf;
}
//---------------------------------------------------------------------------

void TForm1::opendat2mac(){
//#define MAX_NUMBER_OF_SECTIONS 64
   mac<unsigned __int32> sa,uk,len,sa3;
   mac<unsigned __int16> n,*sa2/*[MAX_NUMBER_OF_SECTIONS]*/,*n2/*[MAX_NUMBER_OF_SECTIONS]*/,id,nam/*,rel*/;
   int i,j,p=0; char ix[5]={0,0,0,0,0};
   unsigned __int32 sk;
   AnsiString *idx/*[MAX_NUMBER_OF_SECTIONS]*/;
   TMemoryStream* ms=new TMemoryStream;
/*   for(i=0;i<MAX_NUMBER_OF_RES;i++){
      if(ms_res[i]){ delete ms_res[i]; ms_res[i]=NULL; }
   }*/
   delall();
   ms->LoadFromFile(filename);
   ms->Seek(4,soFromBeginning);
   ms->Read(&sa,4);
//   ms->Seek(sa.value()+0x18,soFromBeginning);
//   ms->Read(&rel,2);
   ms->Seek(sa.value()+/*rel.value()*/0x1C,soFromBeginning);
//   ShowMessage(IntToHex((int)sa.value(),8));
   ms->Read(&n,2);
//   ShowMessage(IntToHex((int)ln.value(),4));
/*   if(n.value()>=MAX_NUMBER_OF_SECTIONS){
      ShowMessage("Tl sok section!");
      return;
   }*/
   sa2=new mac<unsigned __int16>[n.value()+1];
   n2=new mac<unsigned __int16>[n.value()+1];
   idx=new AnsiString[n.value()+1];
   nor=0;
   for(i=0;i<=n.value();i++){
      ms->Read(ix,4);
      ms->Read(&(n2[i]),2);
      ms->Read(&(sa2[i]),2);
      idx[i]=Trim(ix);
      nor+=n2[i].value()+1;
   }
   createall(nor);
   for(i=0;i<=n.value();i++){
      ms->Seek(sa.value()+/*rel.value()*/0x1C+sa2[i].value(),soFromBeginning);
      for(j=0;j<=n2[i].value();j++){
         ms->Read(&id,2);
         ms->Read(&nam,2);
         ms->Read(&sa3,4);
         ms->Read(&uk,4);
         sk=ms->Position;
         ms->Seek((sa3.value()&0xFFFFFF)+0x100,soFromBeginning);
         ms->Read(&len,4);
         poprec[p].id=id.value();
         poprec[p].sa=(sa3.value()&0xFFFFFF)+0x100;
         poprec[p].len=len.value();
         strcpy(poprec[p].idx,idx[i].c_str());
         ms->Seek(sk,soFromBeginning);
//         ms_res[p]=new TMemoryStream();
         ms_res[p]->SetSize(poprec[p].len);
         ms_res[p]->Write((char*)ms->Memory+poprec[p].sa+4,poprec[p].len);
         p++;
/*         if(p>=MAX_NUMBER_OF_RES){
            ShowMessage("Tl sok erforrs!");
            return;
         }*/
      }
   }
   nor=p;
   delete ms;
   delete[]sa2;
   delete[]n2;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ActionPrince2MacExecute(TObject *Sender)
{
 ver=3; ActionPrince2Mac->Checked=true; Prince2Mac->Checked=true;
 ActionVga1Execute(Sender);
 ActionEga1->Enabled=false;
 ActionCga1->Enabled=false;
 OpenDialog1->FilterIndex=2;
 SaveDialog1->FilterIndex=2;
}
//---------------------------------------------------------------------------
void TForm1::showpalettemac(int ix,bool exp){
 if(exp) {showbinary(ix,true); return;}
 TMemoryStream* ms=ms_res[ix];
 mac<unsigned __int16> n;
 unsigned char ch;
 int i,j,p; TColor c=(TColor)0;
 ms->Seek(0,soFromBeginning);
 ms->Read(&n,2);
 kep->Canvas->Brush->Color=clWhite;
 kep->Canvas->Pen->Color=clBlack;
 kep->Width=256;
 kep->Height=256;
 for(i=0;i<16;i++){
    for(j=0;j<16;j++){
       kep->Canvas->Rectangle(j*16,i*16,j*16+16,i*16+16);
       kep->Canvas->MoveTo(j*16,i*16);
       kep->Canvas->LineTo(j*16+16,i*16+16);
    }
 }
 for(p=0;p<n.value();p++){
    ms->Read((char*)(&c)+0,1);
    ms->Read((char*)(&c)+1,1);
    ms->Read((char*)(&c)+2,1);
    ms->Read(&ch,1);
    j=ch&15; i=ch>>4;
    kep->Canvas->Brush->Color=TColor(c);
    kep->Canvas->Rectangle(j*16,i*16,j*16+16,i*16+16);
 }
}
//---------------------------------------------------------------------------
void TForm1::showbitmapmac(int ix,int pal,AnsiString idx,int offs,bool exp){
   mac<unsigned __int16> wh,hh,_16,wh2; int bpp,dir,i,j,k,l; unsigned char ch,c;
   int x,y,*c1,*c2,b; unsigned __int16 d1; unsigned char* p;
   int wb,base,wb2; unsigned __int32 _32;
   TColor col=(TColor)0; AnsiString st;
   TMemoryStream* ms2=new TMemoryStream;
   TMemoryStream* ms_pal=new TMemoryStream;
   TMemoryStream* ms_exp;
   TMemoryStream* ms=ms_res[ix];
   if(exp) ms_exp=new TMemoryStream;
   ms->Seek(0,soFromBeginning);
   ms->Read(&_16,2);
   ms->Read(&wh2,2); ms->Read(&wh,2); ms->Read(&hh,2);
   if(!exp){kep->Width=wh.value(); kep->Height=hh.value();}
//   ShowMessage(IntToStr(wh)+"x"+IntToStr(hh));
   /*ShowMessage*///Form1->Caption=(IntToHex(_16,4));
   int bpp2=(_16.value()>>12)&0xF,cmeth=(_16.value()>>8)&0xF+((_16.value()&0xF)<<4);
   switch(bpp2){
      case 0x9: bpp=1; break;
      case 0xB: bpp=8; break;
      default: ShowMessage("Ismeretlen bitmlysg! "+IntToHex(bpp2,1)); goto Vege;
   }
   ms2->SetSize(/*(wh.value()*bpp+7)/8*/wh2.value()*hh.value());
   ms->Seek(0xC,soFromBeginning);
   switch(cmeth){
      case 0: dir=0;
//      wh=wh2;
      for(i=0;i<poprec[/*ListBox1->ItemIndex*/ix].len-0x0C;i++){
         ms->Read(&ch,1);
         ms2->Write(&ch,1);
      }
      break;
      case 1: dir=0;
      unrlemac(ms,ms2,hh.value(),wh2.value());
      break;
      case 2: dir=0;
//      ShowMessage("!!!");
//      unrlemac(ms,ms2,poprec[/*ListBox1->ItemIndex*/ix].len-0x0C);
      unrle3(ms,ms2,poprec[ix].len-0x0C);
      break;
      case 4: dir=0;
      {mac<unsigned __int32> ln;
      ms->Read(&ln,4);
      unlzg2(ms,ms2,ln.value());}
      break;
      case 5: dir=0;
      unlzgrlemac(ms,ms2,hh.value(),wh2.value());
      break;
      case 6: dir=0;
      unlzgrle3mac(ms,ms2,hh.value(),wh2.value());
      break;
      default: ShowMessage("Ismeretlen tmrts! "+IntToHex(cmeth,2)); goto Vege;
   }
   if(dir) {c1=&x,c2=&y,d1=hh.value();} else {c1=&y,c2=&x,d1=/*(wh.value()*bpp+7)/8*/wh2.value();}
//   kep->PixelFormat=pf24bit;
   b=8/bpp;
   for(i=0;i<nor;i++){
      if(poprec[i].id==pal&&(ver==1||AnsiString(poprec[i].idx)==idx)) break;
   }
   if(i<nor){
      TMemoryStream* ms=ms_res[i];
      mac<unsigned __int16> n;
      if(exp){
         ms_pal->SetSize(4<<bpp);
         ms_pal->Seek(0,soFromBeginning);
         col=0;
         for(i=0;i<1<<bpp;i++){
            ms_pal->Write(&col,4);
         }
         ms->Seek(0,soFromBeginning);
         ms->Read(&n,2);
         for(i=0;i<n.value();i++){
            ms->Read(&col,3);
            ms->Read(&ch,1); ch-=offs;
            ms_pal->Seek(ch*4,soFromBeginning);
            ms_pal->Write((char*)(&col)+2,1);
            ms_pal->Write((char*)(&col)+1,1);
            ms_pal->Write((char*)(&col)+0,1);
            ms_pal->Write((char*)(&col)+3,1);
         }
      }else{
         ms_pal->SetSize(4<<bpp);
         ms_pal->Seek(0,soFromBeginning);
         col=0;
         for(i=0;i<1<<bpp;i++){
            ms_pal->Write(&col,4);
         }
         ms->Seek(0,soFromBeginning);
         ms->Read(&n,2);
         for(i=0;i<n.value();i++){
            ms->Read(&col,3);
            ms->Read(&ch,1); ch-=offs;
            ms_pal->Seek(ch*4,soFromBeginning);
            ms_pal->Write(&col,4);
         }
         if(bpp==1) ShowMessage("b/w");
      }
   }else{
      for(j=0;j<(sm=='v'?1:4);j++)
      for(i=0;i<(1<<bpp);i++){
         col=(TColor)((i<<(8-bpp))*0x010101);
         ms_pal->Write(&col,4);
      }
   }
//   if(exp)
   wb=(wh.value()*bpp+7)>>3;
   if(exp){
      unsigned __int16 _16;
      //BITMAPINFOHEADER
      ms_exp->SetSize(0x36+(4<<bpp)+wb*hh.value());
      wb2=(wb+3)&~3;
      ms_exp->Write("BM",2);
      _32=0x36+(4<<bpp)+wb2*hh.value(); ms_exp->Write(&_32,4);
      _32=0; ms_exp->Write(&_32,4);
      _32=0x36+(4<<bpp); ms_exp->Write(&_32,4);
      _32=40; ms_exp->Write(&_32,4);
      _32=wh.value(); ms_exp->Write(&_32,4);
      _32=hh.value(); ms_exp->Write(&_32,4);
      _16=1; ms_exp->Write(&_16,2);
      _16=bpp; ms_exp->Write(&_16,2);
      _32=0; ms_exp->Write(&_32,4);
      _32=wb2*hh.value(); ms_exp->Write(&_32,4);
      _32=0xEC4; ms_exp->Write(&_32,4);
      _32=0xEC4; ms_exp->Write(&_32,4);
      _32=0; ms_exp->Write(&_32,4);
      _32=0; ms_exp->Write(&_32,4);
      ms_exp->Write(ms_pal->Memory,4<<bpp);
      base=0x36+(4<<bpp);
   }
   if(!exp) kep->PixelFormat=pf24bit;
   for(y=0;y<hh.value();y++){
      if(!exp) p=(unsigned char*)kep->ScanLine[y];
      if(exp) ms_exp->Seek(base+(hh.value()-1-y)*wb2,soFromBeginning);
      for(x=0;x<wb;x++){
         ch=((unsigned char*)(ms2->Memory))[(*c1)*d1+(*c2)];
         if(exp)
            ms_exp->Write(&ch,1);
         else{
            for(i=0;i<b&&x*b+i<wh.value();i++){
   //            c=ch&((1<<bpp)-1); ch>>=bpp;
               c=ch>>(8-bpp); ch<<=bpp;
   //            *(p++)=c; *(p++)=c; *(p++)=c;
   //            kep->Canvas->Pixels[x*b+(b-1)-i][y]=((TColor*)ms_pal->Memory)[c];
               switch(sm){
                  case 'v':
                  col=((TColor*)ms_pal->Memory)[c];
                  break;
                  case 'e':
                  col=((TColor*)ms_pal->Memory)[c+((x*b+i)&1)*(2<<bpp)+(y&1)*(1<<bpp)];
                  break;
                  case 'c':
                  col=((TColor*)ms_pal->Memory)[c+((x*b+i)&1)*(2<<bpp)+(y&1)*(1<<bpp)];
                  break;
               }
               *(p++)=(col>>16)&0xFF;
               *(p++)=(col>>8)&0xFF;
               *(p++)=col&0xFF;
            }
         }
      }
   }
   Vege:
   delete ms2;
   if(exp){
      AnsiString s;
/*      s=mi2->ReadString(treat,
         ((ver!=1)?AnsiString(poprec[ix].idx)+",":AnsiString(""))+IntToStr(poprec[ix].id),"");
      if(s=="") s="unknown\\"+UpperCase(ExtractFileName(OpenDialog1->FileName))+
         ((ver!=1)?"\\"+AnsiString(poprec[ix].idx):AnsiString(""))+"\\res"+IntToStr(poprec[ix].id)+".bmp";*/
      s=getexpfilename(poprec[ix].idx,poprec[ix].id,".bmp");
      s=exppath+s;
      mkdir_recursive(ExtractFilePath(s));
      ms_exp->SaveToFile(s);
      delete ms_exp;
   }
   st.printf(" %d*%d, %d bpp, %s",wh.value(),hh.value(),bpp,compmac[cmeth]);
   StatusBar1->SimpleText=StatusBar1->SimpleText+st;
}
//---------------------------------------------------------------------------
void TForm1::unrlemac(TMemoryStream* ms_in,TMemoryStream* ms_out,int lines,int linesize){
   mac<unsigned __int16> si; int p=0/*pp=0,i=0,*//*en*/;
//   int ln=size-2;
//   en=ms_in->Position+size;
//   Ujra:
   int i=0;
   p=0;
   do{
      ms_out->Seek(i*linesize,soFromBeginning);
      ms_in->Read(&si,2); p+=2;
      unrle2(ms_in,ms_out,si.value()); p+=si.value();
      i++;
   }while(/*p<ln*/i<lines);
//   if(ms_in->Position<en) goto Ujra;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::ActionCopy1Execute(TObject *Sender)
{
 TClipboard* cb=Clipboard();
 cb->Assign(kep);
// delete cb;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ActionSzerk1Execute(TObject *Sender)
{
 int ix=ListBox1->ItemIndex;
 if(ix==-1) return;
 int id=poprec[ix].id;
// HINSTANCE h;
 BOOL h;
 PROCESS_INFORMATION proc_inf;
 STARTUPINFO stup_inf;
 stup_inf.cb=0x44;
 stup_inf.lpReserved=0;
 stup_inf.cb=0;
 stup_inf.lpReserved=0;
 stup_inf.lpDesktop=0;
 stup_inf.lpTitle=0;
 stup_inf.dwX=0;
 stup_inf.dwY=0;
 stup_inf.dwXSize=0;
 stup_inf.dwYSize=0;
 stup_inf.dwXCountChars=0;
 stup_inf.dwYCountChars=0;
 stup_inf.dwFillAttribute=0;
 stup_inf.dwFlags=0;
 stup_inf.wShowWindow=0;
 stup_inf.cbReserved2=0;
 stup_inf.lpReserved2=0;
 stup_inf.hStdInput=0;
 stup_inf.hStdOutput=0;
 stup_inf.hStdError=0;

 AnsiString idx=AnsiString(poprec[ix].idx);
 AnsiString idxid=((ver!=1)?idx+",":AnsiString(""))+IntToStr(id);
 AnsiString path=ExtractFilePath(Application->ExeName)+"tmp\\";
/*    mi2->ReadString(treat,
    ((ver!=1)?AnsiString(poprec[ix].idx)+",":AnsiString(""))+IntToStr(poprec[ix].id),"");*/
 exppath=path;
 show(ix,true);
 AnsiString file=path+expfilename;
// h=ShellExecuteA(Form1->Handle,NULL,"C:\\WINDOWS\\system32\\mspaint.exe",("\""+file+"\"").c_str(),path.c_str(),SW_MAXIMIZE);
 AnsiString s,s2; int p;
 s=mi->ReadString(treat,
    ((ver!=1)?AnsiString(poprec[ix].idx)+",":AnsiString(""))+IntToStr(poprec[ix].id),"binary");
 p=s.Pos(","); if(p==0) p=s.Length()+1;
 s2=s.SubString(1,p-1);
 AnsiString editor=sl_edit->Values[s2];
 if(editor=="") return ShowMessage("Nincs szerkeszt belltva ehhez a tpushoz: "+s2);
 h=CreateProcessA(editor.c_str(),("\""+editor+"\" \""+file+"\"").c_str(),NULL,NULL,0,0,NULL,path.c_str(),&stup_inf,&proc_inf);
// if((int)h<=32) return;
 if(!h) return;
// WaitForSingleObject(proc_inf.hProcess,INFINITE);
 if(Application->MessageBoxA("Nyomj OK-t, ha befejezted a szerkesztst s "
    "menteni akarod a vltoztatsokat, Mgse-t, ha nem.","Szerkeszts",MB_OKCANCEL)==IDOK){
    import(idxid,file,ix);
    showlist();
    ListBox1->ItemIndex=ix;
    ListBox1Click(Sender);
 }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ActionTreat1Execute(TObject *Sender)
{
 treat=InputBox("Kezels mint","",treat);
}
//---------------------------------------------------------------------------

void TForm1::unrle3(TMemoryStream* ms_in,TMemoryStream* ms_out,int size){
   int p=0,i; unsigned char ch; unsigned char ch2;
   while(p<size){
      ms_in->Read(&ch,1);
      p++;
      if(ch&0x80){
         ms_in->Read(&ch2,1);
         p++;
         for(i=0;i<(ch&0x7F)+3;i++){
            ms_out->Write(&ch2,1);
         }
      }else{
         for(i=0;i<ch;i++){
            ms_in->Read(&ch2,1);
            ms_out->Write(&ch2,1);
            p++;
         }
      }
   }
// ms_out->SaveToFile(ExtractFilePath(Application->ExeName)+"dump");
}
//---------------------------------------------------------------------------
AnsiString TForm1::getexpfilename(char idx[],int id,AnsiString defext){
 AnsiString s;
      s=mi2->ReadString(treat,
         ((ver!=1)?AnsiString(idx)+",":AnsiString(""))+IntToStr(id),"");
      if(s=="") s="unknown\\"+filename2+
         ((ver!=1)?"\\"+AnsiString(idx):AnsiString(""))+"\\res"+IntToStr(id)+defext;
 expfilename=s;
 return s;

}
//---------------------------------------------------------------------------
void TForm1::importtext(TMemoryStream* ms_imp,AnsiString file,bool fo,bool li){
   TStringList* sl=new TStringList;
   TMemoryStream* ms_mid=new TMemoryStream;
   AnsiString s;
   sl->LoadFromFile(file);
   ms_mid->SetSize(0);
   ms_mid->Seek(0,soFromBeginning);
   ms_imp->SetSize(0);
   ms_imp->Seek(0,soFromBeginning);
   if(li) list(sl,ms_mid); else{
      s=sl->Strings[0];
//      ShowMessage(IntToStr(ms_mid->Size));
//      ShowMessage(IntToStr(s.Length()+1));
      ms_mid->Write(s.c_str(),s.Length()+1);
//      ShowMessage(IntToStr(ms_mid->Size));
   }
   if(fo) four(ms_mid,ms_imp); else ms_imp->Write(ms_mid->Memory,ms_mid->Size);
   delete ms_mid;
   delete sl;
}
//---------------------------------------------------------------------------
void TForm1::four(TMemoryStream* ms_input,TMemoryStream* ms_output){
   TMemoryStream* ms_hf=new TMemoryStream;
   ms_hf->LoadFromFile(ExtractFilePath(Application->ExeName)+"PR2HFMAN.bin");
   char hf[128];
   ms_hf->Seek(0,soFromBeginning);
   ms_hf->Read(hf,128);
   delete ms_hf;
   TMemoryStream* ms_mid=new TMemoryStream;
   bitstack bs; char ch,ch2,huf,maxhuf=0; int i,j,bi=5;
   unsigned __int16 _16;
   ms_input->Seek(0,soFromBeginning);
   ms_mid->SetSize(ms_input->Size);
   ms_mid->Seek(0,soFromBeginning);
   ms_output->SetSize(0);
   ms_output->Seek(0,soFromBeginning);
   for(i=0;i<ms_input->Size;i++){
      ms_input->Read(&ch,1);
      for(j=0;j<128;j++){
         if(hf[j]==ch) break;
      }
      if(j==128) j=0;
      huf=j;
      ms_mid->Write(&huf,1);
      if(huf>maxhuf) maxhuf=huf;
   }
   while(maxhuf>>bi) bi++;
   ms_mid->Seek(0,soFromBeginning);
   _16=ms_input->Size;
   ms_output->Write(&_16,2);
   bs.write(ms_output,2,bi-5);
   for(i=0;i<ms_mid->Size;i++){
      ms_mid->Read(&ch,1);
      if(ch==0 || ch>>4){
         bs.write(ms_output,4,0);
         bs.write(ms_output,bi,ch);
      }else{
         bs.write(ms_output,4,ch);
      }
   }
   bs.flush(ms_output);
   delete ms_mid;
}
//---------------------------------------------------------------------------
void TForm1::list(TStringList* sl_input,TMemoryStream* ms_output){
   int i,n=0; AnsiString s; bool d; char ch=0;
   ms_output->SetSize(0);
   ms_output->Seek(0,soFromBeginning);
   ms_output->Write(&ch,1);
   for(i=0;i<sl_input->Count;i++){
      s=sl_input->Strings[i];
      ms_output->Write(s.c_str(),s.Length());
      d=false;
      if(i+1<sl_input->Count) if(sl_input->Strings[i+1]==delim) d=true;
      ch=d?0:13;
      ms_output->Write(&ch,1);
      if(d){ i++; n++; }
   }
   ch=n;
   ms_output->Seek(0,soFromBeginning);
   ms_output->Write(&ch,1);
}
//---------------------------------------------------------------------------
void TForm1::showwave(int ix,bool exp,bool pop2){
   TMemoryStream* ms=ms_res[ix];
   TMemoryStream* ms_wave=new TMemoryStream;
   unsigned char ch,bd; unsigned __int16 sr,_16; unsigned __int32 len;
   AnsiString st;
   ms->Seek(0,soFromBeginning);
   if(!pop2){
      ms->Read(&ch,1);
      ms->Read(&sr,2);
      ms->Read(&len,4);
      ms->Read(&bd,1);
   }else{
      ms->Read(&ch,1);
      ms->Read(&sr,2);
      ms->Read(&bd,1);
      ms->Read(&len,4);
      ms->Read(&_16,2);
   }
   len&=0xFFFF;
   st.printf(" %d Hz, %d bits",sr,bd);
   StatusBar1->SimpleText=StatusBar1->SimpleText+st;
   if(bd==255){
      StatusBar1->SimpleText=StatusBar1->SimpleText+", compressed";
      delete ms_wave;
      return;
   }
   int msec=(len*8*1000)/(bd*sr);
   int sec=msec/1000; msec%=1000;
   int min=sec/60; sec%=60;
   st.printf(", length %d:%02d.%03d",min,sec,msec);
   StatusBar1->SimpleText=StatusBar1->SimpleText+st;
   int chan=1;
   int sr2=(sr*bd*chan)>>3;
   int ba=(chan*bd)>>3;
   WAVEFORMATEX whd; unsigned __int32 _32;
   whd.wFormatTag=1;
   whd.nChannels=chan;
   whd.nSamplesPerSec=sr;
   whd.nAvgBytesPerSec=sr2;
   whd.nBlockAlign=ba;
   whd.wBitsPerSample=bd;
   whd.cbSize=0;
   _32='RIFF'; ms_wave->Write(&_32,4);
   _32=len+20+sizeof(whd); ms_wave->Write(&_32,4);
   _32='WAVE'; ms_wave->Write(&_32,4);
   _32='fmt '; ms_wave->Write(&_32,4);
   _32=sizeof(whd); ms_wave->Write(&_32,4);
   ms_wave->Write(&whd,sizeof(whd));
   _32='data'; ms_wave->Write(&_32,4);
   _32=len; ms_wave->Write(&_32,4);
   if(len) ms_wave->CopyFrom(ms,len);
   if(exp){
      AnsiString s;
      s=getexpfilename(poprec[ix].idx,poprec[ix].id,".wav");
      s=exppath+s;
      mkdir_recursive(ExtractFilePath(s));
      ms_wave->SaveToFile(s);
   }else{
      PlaySoundA((char*)ms_wave->Memory,NULL,SND_MEMORY);
   }
   delete ms_wave;
}
//---------------------------------------------------------------------------
void TForm1::delall(){
   int i;
   if(ms_res){
      for(i=0;i<nor;i++) if(ms_res[i]) delete ms_res[i];
      delete[]ms_res; ms_res=NULL;
   }
   if(poprec){ delete[]poprec; poprec=NULL; }
   nor=0;
}
//---------------------------------------------------------------------------
void TForm1::createall(int n){
   int i;
   ms_res=new TMemoryStream*[nor];
   for(i=0;i<nor;i++) ms_res[i]=new TMemoryStream;
   poprec=new Tpoprec[nor];
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Frissites1Click(TObject *Sender)
{
 switch(ver){
    case 1: opendat1(); break;
    case 2: opendat2(); break;
    case 3: opendat2mac(); break;
 }
 Form1->Caption=filename;
 filename2=UpperCase(ExtractFileName(filename));
 treat=IntToStr(ver)+"_"+filename2;
 showlist();
}
//---------------------------------------------------------------------------
void TForm1::unlzgrlemac(TMemoryStream* ms_in,TMemoryStream* ms_out,int hh,int wh){
   TMemoryStream* ms_mid=new TMemoryStream;
   mac<unsigned __int32> ln;
   ms_in->Read(&ln,4);
   ms_mid->SetSize(ln.value());
   ms_mid->Seek(0,soFromBeginning);
   unlzg2(ms_in,ms_mid,ln.value());
   ms_mid->Seek(0,soFromBeginning);
   unrlemac(ms_mid,ms_out,hh,wh);
   delete ms_mid;
}
//---------------------------------------------------------------------------
void TForm1::unlzgrle3mac(TMemoryStream* ms_in,TMemoryStream* ms_out,int hh,int wh){
   TMemoryStream* ms_mid=new TMemoryStream;
   mac<unsigned __int32> ln;
   ms_in->Read(&ln,4);
   ms_mid->SetSize(ln.value());
   ms_mid->Seek(0,soFromBeginning);
   unlzg2(ms_in,ms_mid,ln.value());
   ms_mid->Seek(0,soFromBeginning);
   unrle3(ms_mid,ms_out,ln.value());
   delete ms_mid;
}
//---------------------------------------------------------------------------

