//---------------------------------------------------------------------------

#ifndef PrDatViewH
#define PrDatViewH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ActnList.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <Dialogs.hpp>
#include <inifiles.hpp>
#include <ComCtrls.hpp>
#include <StdActns.hpp>
#include <Clipbrd.hpp>
#include <mmsystem.h> // WAVEFORMATEX, PlaySoundA
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
        TListBox *ListBox1;
        TPanel *Panel1;
        TMainMenu *MainMenu1;
        TActionList *ActionList1;
        TAction *ActionMegnyitas1;
        TMenuItem *Fajl1;
        TMenuItem *Megnyitas1;
        TOpenDialog *OpenDialog1;
        TPaintBox *PaintBox1;
        TMenuItem *Nezet1;
        TMenuItem *vga1;
        TMenuItem *ega1;
        TMenuItem *cga1;
        TAction *ActionVga1;
        TAction *ActionEga1;
        TAction *ActionCga1;
        TAction *ActionPrince1;
        TAction *ActionPrince2;
        TMenuItem *N1;
        TMenuItem *Prince1;
        TMenuItem *Prince2;
        TAction *ActionReload1;
        TMenuItem *Reload1;
        TScrollBox *ScrollBox1;
        TAction *ActionZoomIn1;
        TAction *ActionZoomOut1;
        TAction *ActionExportAll1;
        TMenuItem *Export1;
        TAction *ActionImportAll1;
        TMenuItem *Import1;
        TAction *ActionMentes1;
        TMenuItem *Mentes1;
        TSaveDialog *SaveDialog1;
        TAction *ActionCompressRaw1;
        TAction *ActionCompressMin1;
        TAction *ActionCompressMed1;
        TAction *ActionCompressMax1;
        TMenuItem *Beallitasok1;
        TMenuItem *CompressRaw1;
        TMenuItem *CompressMin1;
        TMenuItem *CompressMed1;
        TMenuItem *CompressMax1;
        TStatusBar *StatusBar1;
        TAction *ActionPrince2Mac;
        TMenuItem *Prince2Mac;
        TMenuItem *N2;
        TMenuItem *ZoomIn1;
        TMenuItem *ZoomOut1;
        TMenuItem *Szerkesztes1;
        TEditCopy *ActionCopy1;
        TMenuItem *CopyImage1;
        TMenuItem *Kepszerkesztese1;
        TAction *ActionSzerk1;
        TAction *ActionTreat1;
        TMenuItem *TreatAs1;
        TMenuItem *Frissites1;
        void __fastcall ActionMegnyitas1Execute(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall ListBox1Click(TObject *Sender);
        void __fastcall PaintBox1Paint(TObject *Sender);
        void __fastcall ActionVga1Execute(TObject *Sender);
        void __fastcall ActionEga1Execute(TObject *Sender);
        void __fastcall ActionCga1Execute(TObject *Sender);
        void __fastcall ActionPrince1Execute(TObject *Sender);
        void __fastcall ActionPrince2Execute(TObject *Sender);
        void __fastcall ActionReload1Execute(TObject *Sender);
        void __fastcall ActionZoomIn1Execute(TObject *Sender);
        void __fastcall ActionZoomOut1Execute(TObject *Sender);
        void __fastcall ActionExportAll1Execute(TObject *Sender);
        void __fastcall ActionImportAll1Execute(TObject *Sender);
        void __fastcall ActionMentes1Execute(TObject *Sender);
        void __fastcall ActionCompressRaw1Execute(TObject *Sender);
        void __fastcall ActionCompressMin1Execute(TObject *Sender);
        void __fastcall ActionCompressMed1Execute(TObject *Sender);
        void __fastcall ActionCompressMax1Execute(TObject *Sender);
        void __fastcall ActionPrince2MacExecute(TObject *Sender);
        void __fastcall ActionCopy1Execute(TObject *Sender);
        void __fastcall ActionSzerk1Execute(TObject *Sender);
        void __fastcall ActionTreat1Execute(TObject *Sender);
        void __fastcall Frissites1Click(TObject *Sender);
private:	// User declarations
public:		// User declarations
        void showbitmap(int,int,AnsiString,int,bool);
        void unrle(TMemoryStream*,TMemoryStream*,int);
        void unrle2(TMemoryStream*,TMemoryStream*,int);
        void unlzg(TMemoryStream*,TMemoryStream*,int);
        void unlzg2(TMemoryStream*,TMemoryStream*,int);
        void unlzgrle(TMemoryStream*,TMemoryStream*,int);
        void showpalettepop1(int,bool);
        void showpaletteraw(int,bool);
        void showpalettepop2(int,bool);
        void opendat1(void);
        void opendat2(void);
        void show(int,bool);
        void showbinary(int,bool);
        void import(AnsiString,AnsiString,int);
        void importbitmap(TMemoryStream*,AnsiString);
        void rle(TMemoryStream*,TMemoryStream*);
        void lzg(TMemoryStream*,TMemoryStream*);
        void lzgrle(TMemoryStream*,TMemoryStream*,int);
        void rle2(TMemoryStream*,TMemoryStream*,int);
        void showlist(void);
        void showfont(int,bool);
        void showtext(int,bool,bool,bool);
        void unlist(TMemoryStream*,TStringList*);
        void unfour(TMemoryStream*,TMemoryStream*);
        void opendat2mac(void);
        void showpalettemac(int,bool);
        void showbitmapmac(int,int,AnsiString,int,bool);
        void unrlemac(TMemoryStream*,TMemoryStream*,int,int);
        void unrle3(TMemoryStream*,TMemoryStream*,int);
        AnsiString getexpfilename(char[],int,AnsiString);
        void importtext(TMemoryStream*,AnsiString,bool,bool);
        void four(TMemoryStream*,TMemoryStream*);
        void list(TStringList*,TMemoryStream*);
        void showwave(int ix,bool exp,bool pop2);
        void delall();
        void createall(int n);
        void unlzgrlemac(TMemoryStream* ms_in,TMemoryStream* ms_out,int hh,int wh);
        void unlzgrle3mac(TMemoryStream* ms_in,TMemoryStream* ms_out,int hh,int wh);

        __fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
class bitstack {
   private:
   int data,level;
   public:
   bitstack(){data=level=0;}
   int read(TMemoryStream* ms,int bits){
      int d;
      while(level<bits){
         data<<=8; level+=8; ms->Read(&data,1);
      }
      d=data>>(level-bits); level-=bits; data&=(1<<level)-1;
      return d;
   }
   void write(TMemoryStream* ms,int bits,int value){
      unsigned char ch;
      data<<=bits; level+=bits;
      data|=value;
      while(level>=8){
         ch=data>>level-8; level-=8; data&=(1<<level)-1;
         ms->Write(&ch,1);
      }
   }
   void flush(TMemoryStream* ms){
      if(level==0) return;
      data<<=8-level;
      ms->Write(&data,1);
      level=0; data=0;
   }
};
#pragma option push
#pragma option -a1
typedef struct{
//   bool ispop2;
//   char index[5];
   unsigned __int16 id;
   unsigned __int32 sa;
   unsigned __int32 len;
   unsigned char flags[3];
   char idx[5];
} Tpoprec;
//#define MAX_NUMBER_OF_RES 512
//Tpoprec poprec[MAX_NUMBER_OF_RES];
Tpoprec* poprec;
template <class T>
class mac {
   private:
   unsigned char data[sizeof(T)];
   public:
   T value(){
      T val=0; int i;
      for(i=0;i<sizeof(T);i++){
         val<<=8; val+=data[i];
      }
      return val;
   }
};
#pragma option pop
//TMemoryStream* ms_res[MAX_NUMBER_OF_RES];
TMemoryStream** ms_res;
//TMemoryStream* ms;
TMemIniFile* mi,*mi2;
Graphics::TBitmap* kep;
int nor; char sm='v'; int ver=1; int zoom=1; int com=2;
AnsiString exppath;
#define rgb(r,g,b) (TColor)RGB(r,g,b)
TColor egacols[16]={
rgb(0,0,0),rgb(0,0,160),rgb(0,167,0),rgb(0,167,160),
rgb(160,0,0),rgb(160,0,160),rgb(160,80,0),rgb(160,167,160),
rgb(80,80,80),rgb(80,80,255),rgb(80,248,80),rgb(80,248,255),
rgb(255,80,80),rgb(0,0,0),rgb(255,248,80),rgb(255,248,255)
};
TColor cgacols[4]={
rgb(0,0,0),rgb(80,248,255),rgb(255,80,255),rgb(255,248,255)
};
char* comp[]={"RAW ltr","RLE ltr","RLE utd","LZG ltr","LZG utd"};
char* comp2[]={"","+RLE ltr"};
char* compmac[]={"RAW ltr","RLE ltr","RLE bw ltr","(3)","LZG ltr","LZG+RLE ltr","LZG+RLE bw ltr"};
const AnsiString delim="---";
AnsiString treat="";
TStringList* sl_edit;
AnsiString filename="",filename2="",expfilename="";
#endif

